#---------------------------------------------------------------------
# Example configuration for a possible web application.  See the
# full configuration options online.
#
#   http://haproxy.1wt.eu/download/1.4/doc/configuration.txt
#
#---------------------------------------------------------------------

#---------------------------------------------------------------------
# Global settings
#---------------------------------------------------------------------
global
    # to have these messages end up in /var/log/haproxy.log you will
    # need to:
    #
    # 1) configure syslog to accept network log events.  This is done
    #    by adding the '-r' option to the SYSLOGD_OPTIONS in
    #    /etc/sysconfig/syslog
    #
    # 2) configure local2 events to go to the /var/log/haproxy.log
    #   file. A line like the following can be added to
    #   /etc/sysconfig/syslog
    #
    #    local2.*                       /var/log/haproxy.log
    #
    log         127.0.0.1 local2

    chroot      /var/lib/haproxy
    pidfile     /var/run/haproxy.pid
    maxconn     4000
    user        haproxy
    group       haproxy
    daemon

    # turn on stats unix socket
    stats socket /var/run/haproxy-stats.sock

    # utilize system-wide crypto-policies
    ssl-default-bind-ciphers PROFILE=SYSTEM
    ssl-default-server-ciphers PROFILE=SYSTEM

#---------------------------------------------------------------------
# common defaults that all the 'listen' and 'backend' sections will
# use if not designated in their block
#---------------------------------------------------------------------
defaults
    mode                    http
    log                     global
    option                  httplog
    option                  dontlognull
    option http-server-close
    option forwardfor       except 127.0.0.0/8
    option                  redispatch
    retries                 3
    maxconn                 3000

#---------------------------------------------------------------------
# kubernetes api frontend
#---------------------------------------------------------------------
frontend kube-api-front
    bind *:6443 #XXX should only bind on internal address
    mode tcp
    default_backend kube-api-back

#---------------------------------------------------------------------
# kubernetes api backend
#---------------------------------------------------------------------
backend kube-api-back
    mode tcp
    balance     roundrobin
    server      ma0 ma0:6443 check
    server      ma1 ma1:6443 check
    server      ma2 ma2:6443 check

#---------------------------------------------------------------------
# etcd frontend
#---------------------------------------------------------------------
frontend etcd-front
    bind *:2379 #XXX should only bind on internal address
    mode tcp
    default_backend etcd-back

#---------------------------------------------------------------------
# etcd backend
#---------------------------------------------------------------------
backend etcd-back
    mode tcp
    balance     roundrobin
    server      db0 db0:2379 check
    server      db1 db1:2379 check
    server      db2 db2:2379 check

#---------------------------------------------------------------------
# merge-api frontend
#---------------------------------------------------------------------
frontend merge-front
    bind *:443
    mode tcp
    default_backend merge-back

#---------------------------------------------------------------------
# merge-api backend
#---------------------------------------------------------------------
backend merge-back
    mode tcp
    balance roundrobin
    server  svc0 svc0:443 check
    server  svc1 svc1:443 check
    server  svc2 svc2:443 check

#---------------------------------------------------------------------
# elasticsearch frontend
#---------------------------------------------------------------------
frontend elasticsearch-front
  bind *:9200 #XXX should only bind on internal address
  mode tcp
  default_backend elasticsearch-back

#---------------------------------------------------------------------
# elasticsearch backend
#---------------------------------------------------------------------
backend elasticsearch-back
  mode tcp
  balance roundrobin
  server db0 db0:9200 check
  server db1 db1:9200 check
  server db2 db2:9200 check

#---------------------------------------------------------------------
# kibana frontend
#---------------------------------------------------------------------
frontend kibana-front
  bind *:5601 #XXX should only bind on internal address
  mode tcp
  default_backend kibana-back

#---------------------------------------------------------------------
# kibana backend
#---------------------------------------------------------------------
backend kibana-back
  mode tcp
  balance roundrobin
  server db0 db0:5601 check
  server db1 db1:5601 check
  server db2 db2:5601 check

